"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// Union types
var UnionNames;
(function (UnionNames) {
    UnionNames[UnionNames["AccessorDeclaration"] = 0] = "AccessorDeclaration";
    UnionNames[UnionNames["AdditiveOperator"] = 1] = "AdditiveOperator";
    UnionNames[UnionNames["AdditiveOperatorOrHigher"] = 2] = "AdditiveOperatorOrHigher";
    UnionNames[UnionNames["ArrayBindingElement"] = 3] = "ArrayBindingElement";
    UnionNames[UnionNames["ArrayBindingOrAssignmentPattern"] = 4] = "ArrayBindingOrAssignmentPattern";
    UnionNames[UnionNames["AssertionExpression"] = 5] = "AssertionExpression";
    UnionNames[UnionNames["AssignmentOperator"] = 6] = "AssignmentOperator";
    UnionNames[UnionNames["AssignmentOperatorOrHigher"] = 7] = "AssignmentOperatorOrHigher";
    UnionNames[UnionNames["AssignmentPattern"] = 8] = "AssignmentPattern";
    UnionNames[UnionNames["BinaryOperator"] = 9] = "BinaryOperator";
    UnionNames[UnionNames["BindingName"] = 10] = "BindingName";
    UnionNames[UnionNames["BindingOrAssignmentElement"] = 11] = "BindingOrAssignmentElement";
    UnionNames[UnionNames["BindingOrAssignmentElementRestIndicator"] = 12] = "BindingOrAssignmentElementRestIndicator";
    UnionNames[UnionNames["BindingOrAssignmentElementTarget"] = 13] = "BindingOrAssignmentElementTarget";
    UnionNames[UnionNames["BindingOrAssignmentPattern"] = 14] = "BindingOrAssignmentPattern";
    UnionNames[UnionNames["BindingPattern"] = 15] = "BindingPattern";
    UnionNames[UnionNames["BitwiseOperator"] = 16] = "BitwiseOperator";
    UnionNames[UnionNames["BitwiseOperatorOrHigher"] = 17] = "BitwiseOperatorOrHigher";
    UnionNames[UnionNames["BlockLike"] = 18] = "BlockLike";
    UnionNames[UnionNames["BooleanLiteral"] = 19] = "BooleanLiteral";
    UnionNames[UnionNames["BreakOrContinueStatement"] = 20] = "BreakOrContinueStatement";
    UnionNames[UnionNames["CallLikeExpression"] = 21] = "CallLikeExpression";
    UnionNames[UnionNames["CaseOrDefaultClause"] = 22] = "CaseOrDefaultClause";
    UnionNames[UnionNames["ClassLikeDeclaration"] = 23] = "ClassLikeDeclaration";
    UnionNames[UnionNames["CommentKind"] = 24] = "CommentKind";
    UnionNames[UnionNames["CompoundAssignmentOperator"] = 25] = "CompoundAssignmentOperator";
    UnionNames[UnionNames["ConciseBody"] = 26] = "ConciseBody";
    UnionNames[UnionNames["DeclarationName"] = 27] = "DeclarationName";
    UnionNames[UnionNames["DeclarationWithTypeParameters"] = 28] = "DeclarationWithTypeParameters";
    UnionNames[UnionNames["DestructuringPattern"] = 29] = "DestructuringPattern";
    UnionNames[UnionNames["EntityName"] = 30] = "EntityName";
    UnionNames[UnionNames["EntityNameExpression"] = 31] = "EntityNameExpression";
    UnionNames[UnionNames["EntityNameOrEntityNameExpression"] = 32] = "EntityNameOrEntityNameExpression";
    UnionNames[UnionNames["EqualityOperator"] = 33] = "EqualityOperator";
    UnionNames[UnionNames["EqualityOperatorOrHigher"] = 34] = "EqualityOperatorOrHigher";
    UnionNames[UnionNames["ExponentiationOperator"] = 35] = "ExponentiationOperator";
    UnionNames[UnionNames["ForInitializer"] = 36] = "ForInitializer";
    UnionNames[UnionNames["ForInOrOfStatement"] = 37] = "ForInOrOfStatement";
    UnionNames[UnionNames["FunctionBody"] = 38] = "FunctionBody";
    UnionNames[UnionNames["FunctionLike"] = 39] = "FunctionLike";
    UnionNames[UnionNames["FunctionLikeDeclaration"] = 40] = "FunctionLikeDeclaration";
    UnionNames[UnionNames["FunctionOrConstructorTypeNode"] = 41] = "FunctionOrConstructorTypeNode";
    UnionNames[UnionNames["HasJSDoc"] = 42] = "HasJSDoc";
    UnionNames[UnionNames["ImportOrExportSpecifier"] = 43] = "ImportOrExportSpecifier";
    UnionNames[UnionNames["JSDocNamespaceBody"] = 44] = "JSDocNamespaceBody";
    UnionNames[UnionNames["JSDocTypeReferencingNode"] = 45] = "JSDocTypeReferencingNode";
    UnionNames[UnionNames["JsxAttributeLike"] = 46] = "JsxAttributeLike";
    UnionNames[UnionNames["JsxChild"] = 47] = "JsxChild";
    UnionNames[UnionNames["JsxOpeningLikeElement"] = 48] = "JsxOpeningLikeElement";
    UnionNames[UnionNames["KeywordTypeNode"] = 49] = "KeywordTypeNode";
    UnionNames[UnionNames["LogicalOperator"] = 50] = "LogicalOperator";
    UnionNames[UnionNames["LogicalOperatorOrHigher"] = 51] = "LogicalOperatorOrHigher";
    UnionNames[UnionNames["Modifier"] = 52] = "Modifier";
    UnionNames[UnionNames["ModuleBody"] = 53] = "ModuleBody";
    UnionNames[UnionNames["ModuleName"] = 54] = "ModuleName";
    UnionNames[UnionNames["ModuleReference"] = 55] = "ModuleReference";
    UnionNames[UnionNames["MultiplicativeOperator"] = 56] = "MultiplicativeOperator";
    UnionNames[UnionNames["MultiplicativeOperatorOrHigher"] = 57] = "MultiplicativeOperatorOrHigher";
    UnionNames[UnionNames["NamedImportBindings"] = 58] = "NamedImportBindings";
    UnionNames[UnionNames["NamedImportsOrExports"] = 59] = "NamedImportsOrExports";
    UnionNames[UnionNames["NamespaceBody"] = 60] = "NamespaceBody";
    UnionNames[UnionNames["ObjectBindingOrAssignmentPattern"] = 61] = "ObjectBindingOrAssignmentPattern";
    UnionNames[UnionNames["ObjectLiteralElementLike"] = 62] = "ObjectLiteralElementLike";
    UnionNames[UnionNames["PostfixUnaryOperator"] = 63] = "PostfixUnaryOperator";
    UnionNames[UnionNames["PrefixUnaryOperator"] = 64] = "PrefixUnaryOperator";
    UnionNames[UnionNames["PropertyName"] = 65] = "PropertyName";
    UnionNames[UnionNames["RelationalOperator"] = 66] = "RelationalOperator";
    UnionNames[UnionNames["RelationalOperatorOrHigher"] = 67] = "RelationalOperatorOrHigher";
    UnionNames[UnionNames["ShiftOperator"] = 68] = "ShiftOperator";
    UnionNames[UnionNames["ShiftOperatorOrHigher"] = 69] = "ShiftOperatorOrHigher";
    UnionNames[UnionNames["SignatureDeclaration"] = 70] = "SignatureDeclaration";
    UnionNames[UnionNames["TemplateLiteral"] = 71] = "TemplateLiteral";
    UnionNames[UnionNames["TypeReferenceType"] = 72] = "TypeReferenceType";
    UnionNames[UnionNames["UnionOrIntersectionTypeNode"] = 73] = "UnionOrIntersectionTypeNode";
})(UnionNames = exports.UnionNames || (exports.UnionNames = {}));
// Base types
var BaseNames;
(function (BaseNames) {
    BaseNames[BaseNames["ClassElement"] = 0] = "ClassElement";
    BaseNames[BaseNames["ClassLikeDeclarationBase"] = 1] = "ClassLikeDeclarationBase";
    BaseNames[BaseNames["Declaration"] = 2] = "Declaration";
    BaseNames[BaseNames["DeclarationStatement"] = 3] = "DeclarationStatement";
    BaseNames[BaseNames["Expression"] = 4] = "Expression";
    BaseNames[BaseNames["FunctionLikeDeclarationBase"] = 5] = "FunctionLikeDeclarationBase";
    BaseNames[BaseNames["IterationStatement"] = 6] = "IterationStatement";
    BaseNames[BaseNames["JSDocContainer"] = 7] = "JSDocContainer";
    BaseNames[BaseNames["JSDocPropertyLikeTag"] = 8] = "JSDocPropertyLikeTag";
    BaseNames[BaseNames["JSDocTag"] = 9] = "JSDocTag";
    BaseNames[BaseNames["JSDocType"] = 10] = "JSDocType";
    BaseNames[BaseNames["LeftHandSideExpression"] = 11] = "LeftHandSideExpression";
    BaseNames[BaseNames["LiteralExpression"] = 12] = "LiteralExpression";
    BaseNames[BaseNames["LiteralLikeNode"] = 13] = "LiteralLikeNode";
    BaseNames[BaseNames["MemberExpression"] = 14] = "MemberExpression";
    BaseNames[BaseNames["NamedDeclaration"] = 15] = "NamedDeclaration";
    BaseNames[BaseNames["Node"] = 16] = "Node";
    BaseNames[BaseNames["ObjectLiteralElement"] = 17] = "ObjectLiteralElement";
    BaseNames[BaseNames["ObjectLiteralExpression"] = 18] = "ObjectLiteralExpression";
    BaseNames[BaseNames["ObjectLiteralExpressionBase"] = 19] = "ObjectLiteralExpressionBase";
    BaseNames[BaseNames["PrimaryExpression"] = 20] = "PrimaryExpression";
    BaseNames[BaseNames["SignatureDeclarationBase"] = 21] = "SignatureDeclarationBase";
    BaseNames[BaseNames["Statement"] = 22] = "Statement";
    BaseNames[BaseNames["TypeElement"] = 23] = "TypeElement";
    BaseNames[BaseNames["TypeNode"] = 24] = "TypeNode";
    BaseNames[BaseNames["UnaryExpression"] = 25] = "UnaryExpression";
    BaseNames[BaseNames["UpdateExpression"] = 26] = "UpdateExpression";
})(BaseNames = exports.BaseNames || (exports.BaseNames = {}));
// Ignored, because they have same value as others ...
var IgnoredKinds;
(function (IgnoredKinds) {
    IgnoredKinds[IgnoredKinds["FirstAssignment"] = 0] = "FirstAssignment";
    IgnoredKinds[IgnoredKinds["FirstBinaryOperator"] = 1] = "FirstBinaryOperator";
    IgnoredKinds[IgnoredKinds["FirstCompoundAssignment"] = 2] = "FirstCompoundAssignment";
    IgnoredKinds[IgnoredKinds["FirstFutureReservedWord"] = 3] = "FirstFutureReservedWord";
    IgnoredKinds[IgnoredKinds["FirstJSDocNode"] = 4] = "FirstJSDocNode";
    IgnoredKinds[IgnoredKinds["FirstJSDocTagNode"] = 5] = "FirstJSDocTagNode";
    IgnoredKinds[IgnoredKinds["FirstKeyword"] = 6] = "FirstKeyword";
    IgnoredKinds[IgnoredKinds["FirstLiteralToken"] = 7] = "FirstLiteralToken";
    IgnoredKinds[IgnoredKinds["FirstNode"] = 8] = "FirstNode";
    IgnoredKinds[IgnoredKinds["FirstPunctuation"] = 9] = "FirstPunctuation";
    IgnoredKinds[IgnoredKinds["FirstReservedWord"] = 10] = "FirstReservedWord";
    IgnoredKinds[IgnoredKinds["FirstTemplateToken"] = 11] = "FirstTemplateToken";
    IgnoredKinds[IgnoredKinds["FirstToken"] = 12] = "FirstToken";
    IgnoredKinds[IgnoredKinds["FirstTriviaToken"] = 13] = "FirstTriviaToken";
    IgnoredKinds[IgnoredKinds["FirstTypeNode"] = 14] = "FirstTypeNode";
    IgnoredKinds[IgnoredKinds["LastAssignment"] = 15] = "LastAssignment";
    IgnoredKinds[IgnoredKinds["LastBinaryOperator"] = 16] = "LastBinaryOperator";
    IgnoredKinds[IgnoredKinds["LastCompoundAssignment"] = 17] = "LastCompoundAssignment";
    IgnoredKinds[IgnoredKinds["LastFutureReservedWord"] = 18] = "LastFutureReservedWord";
    IgnoredKinds[IgnoredKinds["LastJSDocNode"] = 19] = "LastJSDocNode";
    IgnoredKinds[IgnoredKinds["LastJSDocTagNode"] = 20] = "LastJSDocTagNode";
    IgnoredKinds[IgnoredKinds["LastKeyword"] = 21] = "LastKeyword";
    IgnoredKinds[IgnoredKinds["LastLiteralToken"] = 22] = "LastLiteralToken";
    IgnoredKinds[IgnoredKinds["LastPunctuation"] = 23] = "LastPunctuation";
    IgnoredKinds[IgnoredKinds["LastReservedWord"] = 24] = "LastReservedWord";
    IgnoredKinds[IgnoredKinds["LastTemplateToken"] = 25] = "LastTemplateToken";
    IgnoredKinds[IgnoredKinds["LastToken"] = 26] = "LastToken";
    IgnoredKinds[IgnoredKinds["LastTriviaToken"] = 27] = "LastTriviaToken";
    IgnoredKinds[IgnoredKinds["LastTypeNode"] = 28] = "LastTypeNode";
    IgnoredKinds[IgnoredKinds["JSDocTag"] = 29] = "JSDocTag";
})(IgnoredKinds = exports.IgnoredKinds || (exports.IgnoredKinds = {}));
exports.ignoredKindsMap = {
    FirstAssignment: 'EqualsToken',
    FirstBinaryOperator: 'LessThanToken',
    FirstCompoundAssignment: 'PlusEqualsToken',
    FirstFutureReservedWord: 'ImplementsKeyword',
    FirstJSDocNode: 'JSDocTypeExpression',
    FirstJSDocTagNode: 'JSDocTag',
    FirstKeyword: 'BreakKeyword',
    FirstLiteralToken: 'NumericLiteral',
    FirstNode: 'QualifiedName',
    FirstPunctuation: 'OpenBraceToken',
    FirstReservedWord: 'BreakKeyword',
    FirstTemplateToken: 'NoSubstitutionTemplateLiteral',
    FirstToken: 'Unknown',
    FirstTriviaToken: 'SingleLineCommentTrivia',
    FirstTypeNode: 'TypePredicate',
    LastAssignment: 'CaretEqualsToken',
    LastBinaryOperator: 'CaretEqualsToken',
    LastCompoundAssignment: 'CaretEqualsToken',
    LastFutureReservedWord: 'YieldKeyword',
    LastJSDocNode: 'JSDocTypeLiteral',
    LastJSDocTagNode: 'JSDocTypeLiteral',
    LastKeyword: 'OfKeyword',
    LastLiteralToken: 'NoSubstitutionTemplateLiteral',
    LastPunctuation: 'CaretEqualsToken',
    LastReservedWord: 'WithKeyword',
    LastTemplateToken: 'TemplateTail',
    LastToken: 'OfKeyword',
    LastTriviaToken: 'ConflictMarkerTrivia',
    LastTypeNode: 'LiteralType',
};
//# sourceMappingURL=types.js.map