"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typescript_1 = require("typescript");
const bases_1 = require("./bases");
const kinds_1 = require("./kinds");
const types_1 = require("./types");
const unions_1 = require("./unions");
function getDefKinds() {
    const result = [
        ...enumValues(typescript_1.SyntaxKind),
        ...enumValues(types_1.BaseNames),
        ...enumValues(types_1.UnionNames),
    ];
    result.sort();
    return result;
}
exports.getDefKinds = getDefKinds;
function enumValues(enumType) {
    return Object.keys(enumType).filter(o => typeof o === 'string');
}
exports.defs = Object.assign({}, kinds_1.default, bases_1.default, unions_1.default);
//# sourceMappingURL=utils.js.map